<?php
/**
 * AnsprechpartnerJsonldCreate
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Model;

use \ArrayAccess;
use \SLIS\Adapter\Hub\ObjectSerializer;

/**
 * AnsprechpartnerJsonldCreate Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<string, mixed>
 */
class AnsprechpartnerJsonldCreate implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Ansprechpartner.jsonld-create';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'atContext' => '\SLIS\Adapter\Hub\Model\AdresseJsonldCreateContext',
        'atId' => 'string',
        'atType' => 'string',
        'anrede' => 'string',
        'vorname' => 'string',
        'nachname' => 'string',
        'email' => 'string',
        'telefon' => 'string',
        'geburtsdatum' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'atContext' => null,
        'atId' => null,
        'atType' => null,
        'anrede' => null,
        'vorname' => null,
        'nachname' => null,
        'email' => null,
        'telefon' => null,
        'geburtsdatum' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static array $openAPINullables = [
        'atContext' => false,
		'atId' => false,
		'atType' => false,
		'anrede' => true,
		'vorname' => true,
		'nachname' => false,
		'email' => true,
		'telefon' => true,
		'geburtsdatum' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of nullable properties
     *
     * @return array
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return boolean[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Checks if a property is nullable
     *
     * @param string $property
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @param string $property
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        return in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'atContext' => '@context',
        'atId' => '@id',
        'atType' => '@type',
        'anrede' => 'anrede',
        'vorname' => 'vorname',
        'nachname' => 'nachname',
        'email' => 'email',
        'telefon' => 'telefon',
        'geburtsdatum' => 'geburtsdatum'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'atContext' => 'setAtContext',
        'atId' => 'setAtId',
        'atType' => 'setAtType',
        'anrede' => 'setAnrede',
        'vorname' => 'setVorname',
        'nachname' => 'setNachname',
        'email' => 'setEmail',
        'telefon' => 'setTelefon',
        'geburtsdatum' => 'setGeburtsdatum'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'atContext' => 'getAtContext',
        'atId' => 'getAtId',
        'atType' => 'getAtType',
        'anrede' => 'getAnrede',
        'vorname' => 'getVorname',
        'nachname' => 'getNachname',
        'email' => 'getEmail',
        'telefon' => 'getTelefon',
        'geburtsdatum' => 'getGeburtsdatum'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('atContext', $data ?? [], null);
        $this->setIfExists('atId', $data ?? [], null);
        $this->setIfExists('atType', $data ?? [], null);
        $this->setIfExists('anrede', $data ?? [], null);
        $this->setIfExists('vorname', $data ?? [], null);
        $this->setIfExists('nachname', $data ?? [], null);
        $this->setIfExists('email', $data ?? [], null);
        $this->setIfExists('telefon', $data ?? [], null);
        $this->setIfExists('geburtsdatum', $data ?? [], null);
    }

    /**
    * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
    * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
    * $this->openAPINullablesSetToNull array
    *
    * @param string $variableName
    * @param array  $fields
    * @param mixed  $defaultValue
    */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && array_key_exists($variableName, $fields) && is_null($fields[$variableName])) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets atContext
     *
     * @return \SLIS\Adapter\Hub\Model\AdresseJsonldCreateContext|null
     */
    public function getAtContext()
    {
        return $this->container['atContext'];
    }

    /**
     * Sets atContext
     *
     * @param \SLIS\Adapter\Hub\Model\AdresseJsonldCreateContext|null $atContext atContext
     *
     * @return self
     */
    public function setAtContext($atContext)
    {

        if (is_null($atContext)) {
            throw new \InvalidArgumentException('non-nullable atContext cannot be null');
        }

        $this->container['atContext'] = $atContext;

        return $this;
    }

    /**
     * Gets atId
     *
     * @return string|null
     */
    public function getAtId()
    {
        return $this->container['atId'];
    }

    /**
     * Sets atId
     *
     * @param string|null $atId atId
     *
     * @return self
     */
    public function setAtId($atId)
    {

        if (is_null($atId)) {
            throw new \InvalidArgumentException('non-nullable atId cannot be null');
        }

        $this->container['atId'] = $atId;

        return $this;
    }

    /**
     * Gets atType
     *
     * @return string|null
     */
    public function getAtType()
    {
        return $this->container['atType'];
    }

    /**
     * Sets atType
     *
     * @param string|null $atType atType
     *
     * @return self
     */
    public function setAtType($atType)
    {

        if (is_null($atType)) {
            throw new \InvalidArgumentException('non-nullable atType cannot be null');
        }

        $this->container['atType'] = $atType;

        return $this;
    }

    /**
     * Gets anrede
     *
     * @return string|null
     */
    public function getAnrede()
    {
        return $this->container['anrede'];
    }

    /**
     * Sets anrede
     *
     * @param string|null $anrede anrede
     *
     * @return self
     */
    public function setAnrede($anrede)
    {

        if (is_null($anrede)) {
            array_push($this->openAPINullablesSetToNull, 'anrede');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('anrede', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['anrede'] = $anrede;

        return $this;
    }

    /**
     * Gets vorname
     *
     * @return string|null
     */
    public function getVorname()
    {
        return $this->container['vorname'];
    }

    /**
     * Sets vorname
     *
     * @param string|null $vorname vorname
     *
     * @return self
     */
    public function setVorname($vorname)
    {

        if (is_null($vorname)) {
            array_push($this->openAPINullablesSetToNull, 'vorname');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('vorname', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['vorname'] = $vorname;

        return $this;
    }

    /**
     * Gets nachname
     *
     * @return string|null
     */
    public function getNachname()
    {
        return $this->container['nachname'];
    }

    /**
     * Sets nachname
     *
     * @param string|null $nachname nachname
     *
     * @return self
     */
    public function setNachname($nachname)
    {

        if (is_null($nachname)) {
            throw new \InvalidArgumentException('non-nullable nachname cannot be null');
        }

        $this->container['nachname'] = $nachname;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email email
     *
     * @return self
     */
    public function setEmail($email)
    {

        if (is_null($email)) {
            array_push($this->openAPINullablesSetToNull, 'email');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('email', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets telefon
     *
     * @return string|null
     */
    public function getTelefon()
    {
        return $this->container['telefon'];
    }

    /**
     * Sets telefon
     *
     * @param string|null $telefon telefon
     *
     * @return self
     */
    public function setTelefon($telefon)
    {

        if (is_null($telefon)) {
            array_push($this->openAPINullablesSetToNull, 'telefon');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('telefon', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['telefon'] = $telefon;

        return $this;
    }

    /**
     * Gets geburtsdatum
     *
     * @return \DateTime|null
     */
    public function getGeburtsdatum()
    {
        return $this->container['geburtsdatum'];
    }

    /**
     * Sets geburtsdatum
     *
     * @param \DateTime|null $geburtsdatum geburtsdatum
     *
     * @return self
     */
    public function setGeburtsdatum($geburtsdatum)
    {

        if (is_null($geburtsdatum)) {
            array_push($this->openAPINullablesSetToNull, 'geburtsdatum');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('geburtsdatum', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['geburtsdatum'] = $geburtsdatum;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


